//created by Kazesui and bulmabriefs144

#define AUTO_DLLMAIN
#include <DynRPG/DynRPG.h>
#include <cstdlib>
#include <ctime>
#include <iostream>
#include <fstream>
#include <string>
using namespace std;

std::map<std::string, std::string> configuration;
int DynArray[50][1000];
int DynPointer;
int DynMystery;


bool onStartup(char *pluginName) {
               // We load the configuration from the DynRPG.ini file here
               configuration = RPG::loadConfiguration(pluginName);
               return true; // Don't forget to return true so that the start of the game will continue!
}

bool onComment( const char* text,
                const RPG::ParsedCommentData* 	parsedData,
                RPG::EventScriptLine* 	nextScriptLine,
                RPG::EventScriptData* 	scriptData,
                int 	eventId,
                int 	pageId,
                int 	lineId,
                int* 	nextLineId )
{
    std::string cmd = parsedData->command;
    std::string filecode;


    if(!cmd.compare("store_string"))
    {
        RPG::actors[parsedData->parameters[0].number]->name = parsedData->parameters[1].text;
        return false;
    }
    if(!cmd.compare("file_string")) //new code
    {
        ofstream myfile;
        myfile.open ("dynstore.txt");
        myfile << parsedData->parameters[0].text;
        myfile.close();
        return false;
    }
    if(!cmd.compare("store_file")) //new code
    {
        ofstream myfile;
        myfile.open ("dynstore.txt");
        myfile << RPG::actors[parsedData->parameters[0].number]->name;
        myfile.close();
        return false;
    }
    if(!cmd.compare("load_file")) //new code
    {
        ifstream myfile;
        myfile.open ("dynstore.txt");
        getline (myfile, filecode);
        RPG::actors[parsedData->parameters[0].number]->name = filecode;
        myfile.close();
        return false;
    }

    if(!cmd.compare("store_item"))
    {
        RPG::actors[parsedData->parameters[0].number]->name = RPG::getItemName(parsedData->parameters[1].number);
        return false;
    }
    if(!cmd.compare("store_condition"))
    {
        RPG::actors[parsedData->parameters[0].number]->name = RPG::getConditionName(parsedData->parameters[1].number);
        return false;
    }
    if(!cmd.compare("store_skill")) //new code
    {
        RPG::actors[parsedData->parameters[0].number]->name = RPG::getSkillName(parsedData->parameters[1].number);
        return false;
    }

    if(!cmd.compare("store_mystery")) //sets a specific variable to an artificial variable
    {
        DynMystery = parsedData->parameters[0].number;
        return false;
    }
    if(!cmd.compare("random_mystery")) //sets a specific variable to a
    {
        int MinNum = parsedData->parameters[0].number;
        int MaxNum = parsedData->parameters[1].number;
        DynMystery = rand()%(MaxNum+1)+MinNum; // creates a random range
        return false;
    }
    if(!cmd.compare("store_variable")) //sets a specific variable to an artificial variable
    {
        DynMystery = RPG::variables[parsedData->parameters[0].number];
        return false;
    }
    if(!cmd.compare("store_switch")) //sets a specific variable to 0 or 1
    {
        DynMystery = RPG::switches[parsedData->parameters[0].number];
         //doesn't pass if failed
        return false;
    }

    if(!cmd.compare("get_variable")) //sets a specific variable to a
    {
        DynPointer = parsedData->parameters[0].number;
        RPG::variables[DynPointer] = DynMystery; //variable isn't set, it's previously stored

        return false;
    }

    if(!cmd.compare("get_switch"))
    {
        int BooleanVar;
        DynPointer = parsedData->parameters[0].number;
        BooleanVar = DynMystery;
        if (BooleanVar == 0)
        {
            RPG::switches[DynPointer] = false;
        }
        if (BooleanVar == 1)
        {
            RPG::switches[DynPointer] = true;
        }

        return false;
    }

    if(!cmd.compare("mystery_array")) //new code
    {
        int x = parsedData->parameters[0].number;
        int y = parsedData->parameters[1].number;
        DynArray[x][y] = DynMystery;
        // stores mystery into arayy
        return false;
    }

    if(!cmd.compare("store_array")) //new code
    {
        int x = parsedData->parameters[0].number;
        int y = parsedData->parameters[1].number;
        DynArray[x][y] = parsedData->parameters[2].number;
        // parsedData->parameters[].number didn't work
        return false;
    }

    if(!cmd.compare("get_array")) //new code
    {
        int X = parsedData->parameters[0].number;
        int Y = parsedData->parameters[1].number;
        RPG::system->variables[parsedData->parameters[2].number] = DynArray[X][Y];
        return false;
    }

    if(!cmd.compare("compare_array")) //new code
    {
        int TestArray, ArrayValue;
        int X = parsedData->parameters[0].number;
        int Y = parsedData->parameters[1].number;
        TestArray = DynArray[X][Y];
        ArrayValue = parsedData->parameters[2].number;
        if (TestArray == ArrayValue)
            RPG::switches[parsedData->parameters[3].number] = true;
        else
           RPG::switches[parsedData->parameters[3].number] = false;
        // compares an array, and if it matches the number turn a switch ON
        return false;
    }
    if(!cmd.compare("compare_text"))
    {
        std::string A = RPG::actors[parsedData->parameters[1].number]->getName();
        std::string B = parsedData->parameters[2].text;
        if(!A.compare(B))
            RPG::switches[parsedData->parameters[0].number] = true;
        else
            RPG::switches[parsedData->parameters[0].number] = false;
        return false;
    }

    if(!cmd.compare("compare"))
    {
        std::string A = RPG::actors[parsedData->parameters[0].number]->getName();
        std::string B = RPG::actors[parsedData->parameters[1].number]->getName();
        if(!A.compare(B))
            RPG::switches[parsedData->parameters[2].number] = true;
        else
            RPG::switches[parsedData->parameters[2].number] = false;
        return false;
    }
    return true;
}
